/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { try { Document document = commandData.Application.ActiveUIDocument.Document; Autodesk.Revit.DB.View view = commandData.Application.ActiveUIDocument.ActiveView; datumDic.Clear(); ICollection <ElementId> datums = commandData.Application.ActiveUIDocument.Selection.GetElementIds(); if (datums == null || datums.Count == 0) { return(Result.Cancelled); } foreach (ElementId datumRef in datums) { DatumPlane datum = document.GetElement(datumRef) as DatumPlane; if (!datumDic.Keys.Contains(datum.Name)) { datumDic.Add(datum.Name, datum); } } //// Show UI using (AlignmentSetting settingForm = new AlignmentSetting()) { if (settingForm.ShowDialog() == DialogResult.OK) { DatumPlane selectedDatum = datumDic[settingForm.datumList.SelectedItem.ToString()]; Curve baseCurve = selectedDatum.GetCurvesInView(DatumExtentType.ViewSpecific, view).ElementAt(0); Line baseLine = baseCurve as Line; XYZ baseDirect = baseLine.Direction; using (Transaction tran = new Transaction(document, "DatumAlignment")) { tran.Start(); foreach (DatumPlane datum in datumDic.Values) { Curve curve = datum.GetCurvesInView(datum.GetDatumExtentTypeInView(DatumEnds.End0, view), view).ElementAt(0); XYZ direct = (curve as Line).Direction; Curve newCurve = CalculateCurve(curve, baseLine, baseDirect); datum.SetCurveInView(datum.GetDatumExtentTypeInView(DatumEnds.End0, view), view, newCurve); } tran.Commit(); } } } return(Result.Succeeded); } catch (Exception ex) { message = ex.Message; return(Result.Failed); } }